/*  "blkio.scm" WB-tree File Based Associative String Data Base System. */
/*  Copyright (C) 1991, 1992, 1993, 2000, 2003, 2008 Free Software Foundation, Inc. */
/*  */
/*  This program is free software: you can redistribute it and/or modify */
/*  it under the terms of the GNU Lesser General Public License as */
/*  published by the Free Software Foundation, either version 3 of the */
/*  License, or (at your option) any later version. */
/*  */
/*  This program is distributed in the hope that it will be useful, but */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*  Lesser General Public License for more details. */
/*  */
/*  You should have received a copy of the GNU Lesser General Public */
/*  License along with this program.  If not, see */
/*  <http://www.gnu.org/licenses/>. */

/*  routines in this file return pass/fail (#t/#f) */



#include "wbsys.h"
#ifdef unix
# include <sys/types.h>
# include <sys/stat.h>
# include <fcntl.h>
# include <unistd.h>
#endif


int io_diag = 0;


void blkio_init()
{
  
  return;
}


int blkio_create_file(name, bsiz)
     unsigned char *name;
     int bsiz;
{
  return open_output_file(name);
}


int blkio_open_modify_file(name, bsiz)
     unsigned char *name;
     int bsiz;
{
  return open_io_file(name);
}


int blkio_open_read_only_file(name, bsiz)
     unsigned char *name;
     int bsiz;
{
  return open_input_file(name);
}


int blkio_file_close(file)
     int file;
{
  return close_port(file);
}


int blkio_read(file, blk, bsiz, blknum)
     int file;
     unsigned char *blk;
     int bsiz;
     long blknum;
{
  file_position(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytes_read(blk, 0, bsiz, file)))
    {
      if (io_diag)
	dprintf((diagout, "rd:%*s%c %10ld\n", 1+((blk_level(blk))-(leaf)), "", blk_typ(blk), blknum));
      if (blk_typ_P(blk, frl_typ))
	{
	  read_fl_ct = (read_fl_ct)+0x1L;
	}
      else read_ct = (read_ct)+0x1L;
      return !0;
    }
  else {
    dprintf((diagout, ">>>>ERROR<<<<  couldn't read blk %ld\n", blknum));
    return 0;
  }
}


int blkio_write(file, blk, bsiz, blknum)
     int file;
     unsigned char *blk;
     int bsiz;
     long blknum;
{
  file_position(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytes_write(blk, 0, bsiz, file)))
    {
      if (io_diag)
	dprintf((diagout, "wr:%*s%c %10ld\n", 1+((blk_level(blk))-(leaf)), "", blk_typ(blk), blknum));
      if (blk_typ_P(blk, frl_typ))
	{
	  write_fl_ct = (write_fl_ct)+0x1L;
	}
      else write_ct = (write_ct)+0x1L;
      return !0;
    }
  else {
    dprintf((diagout, ">>>>ERROR<<<<  couldn't write blk %ld\n", blknum));
    return 0;
  }
}

/*  Don't need to write block when extending. */

int blkio_file_extend(file, bsiz, blknum)
     int file;
     int bsiz;
     long blknum;
{
  return file_position(file, (bsiz)*(blknum));
}
