/* "Test.cs" WB-tree File Based Associative String Data Base System.
 * Copyright (C) 1991, 1992, 1993, 2000 Free Software Foundation, Inc.
 * Copyright 2007 Clear Methods, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

/* (require 'stdio) */
/* (slib:load-source (in-vicinity (program-vicinity) "wbsys.scm")) */

/* (define diagout stdout) */

/*   call (SCANHAN root-handle [test-prev? #f] [verbose? #t]) */
//package wb;
using System;
using System.Collections;
using wb;

namespace wb
{
    class Test
    {
	private static bool stringEql_P(String a, String b){
	    return a.Equals(b);
	}

	private static ArrayList cons(object elem, ArrayList list){
	    list.Insert(0, elem);
	    return list;
	}

	private static int Length(ArrayList v){
	    return v.Count;
	}

	public static ArrayList scanhan(wb.Han han, params Int32[] args)
	{
	    int errors = 0;
	    int testPrev = 1;	//(args.Length > 0)? args[0] : 0;
	    bool verbose_P = (args.Length > 1)? wb.a2b(args[1]) : false;

	    wb.dprintf("FORWARD key scan\n");
	    {
		String key = null;
		String prior = null;
		int init = 1;
		ArrayList list = new ArrayList();

		Lloop: while (true) {
		    if (verbose_P)
			{
			    wb.dprintf("NEXT KEY IS ");
			    wb.dprintf(key);
			    wb.dprintf("\n");
			}
		    if (wb.a2b(testPrev) && !(wb.a2b(init)))
			{
			    String prevKey = wb.bt_Prev(han, key);
			    if (wb.a2b(wb.a2b(wb.a2b(prevKey)
					      && wb.a2b(prior)
					      && wb.a2b(!(wb.a2b(stringEql_P(prevKey, prior)))))
				       || wb.a2b(wb.a2b(prevKey)
						 && wb.a2b(!(wb.a2b(prior))))
				       || wb.a2b(wb.a2b(prior)
						 && wb.a2b(!(wb.a2b(prevKey)))
						 && wb.a2b(!(wb.a2b(stringEql_P(prior, "")))))))
				{
				    errors = 1+(errors);
				    wb.dprintf("NEXT/PREV error: key= ");
				    wb.dprintf(prior);
				    wb.dprintf("\n");
				    wb.dprintf("   next= ");
				    wb.dprintf(key);
				    wb.dprintf(" prev= ");
				    wb.dprintf(prevKey);
				    wb.dprintf("\n");
				}
			}
		    if (wb.a2b(wb.a2b(wb.a2b(key)
				      && wb.a2b(""!=(key)))
			       || wb.a2b(init)))
			{
			    String Tkey = wb.bt_Next(han, key);
			    prior = key;
			    init = 0;
			    list = wb.a2b(key)
				?cons(key, list)
				:list;
			    key = Tkey;
			    goto Lloop;
			}
		    else {
			if (wb.a2b(testPrev))
			    wb.dprintf("scanhan: " + (errors) + " next/prev errors found.");
			wb.dprintf("scanhan: " + (Length(list)) + " items found.\n");
			return list;
		    }
		}
	    }
	}


	public static int countKeys(wb.Han han)
	{
	    {
		String key = "";
		int ct = 0;
		int init = 1;
		Lloop: while (true) {
		    if (wb.a2b(wb.a2b(wb.a2b(key)
				      && wb.a2b(""!=(key)))
			       || wb.a2b(init)))
			{
			    key = wb.bt_Next(han, key);
			    ct = (ct)+1;
			    init = 0;
			    goto Lloop;
			}
		    else return ct;
		}
	    }
	}


	public static ArrayList scanb(wb.Han han)
	{
	    wb.dprintf("REVERSE key scan\n");
	    {
		String key = null;
		int init = 1;
		ArrayList list = new ArrayList();

		Lloop: while (true) {
		    wb.dprintf("PREV KEY IS ");
		    wb.dprintf(key);
		    wb.dprintf("\n");
		    if (wb.a2b(wb.a2b(wb.a2b(key)
				      && wb.a2b(""!=(key)))
			       || wb.a2b(init)))
			{
			    String Tkey = wb.bt_Prev(han, key);
			    init = 0;
			    list = wb.a2b(key)
				?cons(key, list)
				:list;
			    key = Tkey;
			    goto Lloop;
			}
		    else {
			wb.dprintf("%s: %d items found.\n"+("scanb")+(Length(list)));
			return list;
		    }
		}
	    }
	}


	public static int dbSize(wb.Han han)
	{
	    return (wb.seg_Used(wb.han_Seg(han)))+1;
	}


	public static wb.Han currentBt = null;

	public static wb.Seg currentSeg;

	public static int addKeyNum = 0;

	public static String addStr = "abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz";

	/*  ADD! count [first-key add-key-num] [key-increment 1]  [value-string "abc...xyz"x2] */


	public static void add(int n,params int[] args)
	{
	    int curKeyNum =(args.Length > 0)? args[0] : addKeyNum;
	    int incr = (args.Length > 1)?  args[1] : 1;
	    String addstr = (args.Length > 2)?  args[2] + "" : addStr;

	    int i = 1;
	    while (!(i > n)) {
		String keyStr = curKeyNum + "";
		curKeyNum = (incr)+(curKeyNum);
		wb.bt_Put(currentBt, keyStr, addstr);
		i = (i)+1;
	    }
	    addKeyNum = wb.max(addKeyNum, curKeyNum);
	}

	/*  REMOVE! count first-key [key-increment 1] [unused-arg] */


	public static void remove(int n,int curKey, params int[] args)
	{
	    int incr = wb.a2b(args.Length > 0)? args[0]:1;
	    //		int startTrace = (args.Length > 1)? args[1]:0;

	    int i = 1;
	    while (!(i > n)) {
		String keyStr = curKey + "";
		curKey = (incr)+(curKey);
		wb.bt_Rem(currentBt, keyStr);
		i = (i)+1;
	    }
	    return;
	}

	/*  old test code, still useful! */


	public static void test0(wb.Han bHan)
	{
	    wb.bt_Put(bHan, "foo", "bar");
	    wb.bt_Put(bHan, "foz", "oof");
	    wb.bt_Put(bHan, "fonz", "zonf");
	    wb.bt_Put(bHan, "foo", "raboof");
	    wb.bt_Put(bHan, "food", "thought");
	    scanhan(bHan);
	    wb.bt_Rem(bHan, "foo");
	    wb.bt_Rem(bHan, "fonz");
	    wb.bt_Put(bHan, "foo", "foo=bar");
	    wb.bt_Put(bHan, "foz", "foz=oof");
	    wb.bt_Put(bHan, "fonz", "fonz=zonf");
	    wb.bt_Put(bHan, "foo", "foo=raboof");
	    wb.bt_Put(bHan, "food", "food=for thought");
	    wb.bt_Put(bHan, "very very very long key field", "very very very longer value field");
	    scanhan(bHan);
	}

	/*  THIS IS TEST CASE #1. */
	/*  It is used to test the addition of data elements with similar names */
	/*  to see if the repeat count routine is working correctly */

	public static void test1()
	{
	    wb.Han aHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(aHan, "cat", "6");
	    wb.bt_Put(aHan, "caddy", "4");
	    wb.bt_Put(aHan, "catalytic", "7");
	    wb.bt_Put(aHan, "cadalack", "3");
	    wb.bt_Put(aHan, "catastrophy", "10");
	    wb.bt_Put(aHan, "catastrophic", "9");
	    wb.bt_Put(aHan, "cad", "2");
	    wb.bt_Put(aHan, "cadjole", "5");
	    wb.bt_Put(aHan, "cataract", "8");
	    wb.bt_Put(aHan, "cacky", "1");
	    wb.bt_Put(aHan, "d", "12");
	    scanhan(aHan);
	    wb.dprintf("   TEST 1: nexting on block 'a' index 'cadz'\n");
	    {
		String ansStr = wb.bt_Next(aHan, "cadz");
		wb.dprintf(ansStr);
	    }
	    wb.dprintf("   TEST 1: removing 'd' from 'a'\n");
	    wb.bt_Rem(aHan, "d");
	    scanhan(aHan);
	    wb.dprintf("   TEST 1: removing 'cad' from 'a'\n");
	    wb.bt_Rem(aHan, "cad");
	    scanhan(aHan);
	    wb.closeBt(aHan);
	}

	/*  THIS IS TEST #2 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block completely then adds a new data element and value */
	/*  to the block to make it split */

	public static void test2()
	{
	    wb.Han bHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(bHan, "foo", "bar");
	    wb.bt_Put(bHan, "foz", "oof");
	    wb.bt_Put(bHan, "fonz", "zonf");
	    wb.bt_Put(bHan, "foo", "raboof");
	    wb.bt_Put(bHan, "food", "thought");
	    scanhan(bHan);
	    wb.bt_Rem(bHan, "foo");
	    wb.bt_Rem(bHan, "fonz");
	    scanhan(bHan);
	    wb.dprintf("   TEST 2: creating a full block named 'b'\n");
	    wb.bt_Put(bHan, "foo", "1234567");
	    wb.bt_Put(bHan, "foz", "12345678901");
	    wb.bt_Put(bHan, "fonz", "123456789");
	    wb.bt_Put(bHan, "foo", "1234567890");
	    wb.bt_Put(bHan, "food", "1234567890123456");
	    wb.bt_Put(bHan, "test", "123456789012345678901234");
	    wb.dprintf("   TEST 2: doing a PUT to fill the block\n");
	    wb.bt_Put(bHan, "a", "12345678");
	    scanhan(bHan);
	    wb.closeBt(bHan);
	}

	/*  THIS IS TEST #3 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block , then it tries to make the block split by making */
	/*  the first data element 1 char bigger by replacement */

	public static void test3()
	{
	    wb.Han cHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(cHan, "foo", "1234567");
	    wb.bt_Put(cHan, "foz", "12345678901");
	    wb.bt_Put(cHan, "fonz", "123456789");
	    wb.bt_Put(cHan, "foo", "1234567890");
	    wb.bt_Put(cHan, "food", "1234567890123456");
	    wb.bt_Put(cHan, "test", "123456789012345678901234");
	    wb.bt_Put(cHan, "a", "12345678");
	    scanhan(cHan);
	    wb.dprintf("   TEST 3: split block by increasing first element by one char with PUT\n");
	    wb.bt_Put(cHan, "a", "123456789");
	    scanhan(cHan);
	    wb.closeBt(cHan);
	}

	/*  THIS IS TEST #4 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block , then it tries to make the block split by making */
	/*  a middle data element 1 char bigger by replacement */

	public static void test4()
	{
	    wb.Han dHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(dHan, "foo", "1234567");
	    wb.bt_Put(dHan, "foz", "12345678901");
	    wb.bt_Put(dHan, "fonz", "123456789");
	    wb.bt_Put(dHan, "foo", "1234567890");
	    wb.bt_Put(dHan, "food", "1234567890123456");
	    wb.bt_Put(dHan, "test", "123456789012345678901234");
	    wb.bt_Put(dHan, "a", "12345678");
	    scanhan(dHan);
	    wb.dprintf("   TEST 4: split block by incresing value of a middle element by one with PUT\n");
	    wb.bt_Put(dHan, "foz", "123456789012");
	    scanhan(dHan);
	    wb.closeBt(dHan);
	}

	/*  THIS IS TEST #5 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block , then it tries to make the block split by making */
	/*  the last data element 1 char bigger by replacement */

	public static void test5()
	{
	    wb.Han eHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(eHan, "foo", "1234567");
	    wb.bt_Put(eHan, "foz", "12345678901");
	    wb.bt_Put(eHan, "fonz", "123456789");
	    wb.bt_Put(eHan, "foo", "1234567890");
	    wb.bt_Put(eHan, "food", "1234567890123456");
	    wb.bt_Put(eHan, "test", "123456789012345678901234");
	    wb.bt_Put(eHan, "a", "12345678");
	    scanhan(eHan);
	    wb.dprintf("TEST 5: splitblock by increasing value of the \n"
		       + "last data element by one with PUT\n");
	    wb.bt_Put(eHan, "test", "12345678901234567890123456");
	    scanhan(eHan);
	    wb.closeBt(eHan);
	}

	/*  THIS IS TEST #6 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block , then it deletes the first element. It then */
	/*  tries to make the block split by reentering the first data element */
	/*  with 1 more char than the original */

	public static void test6()
	{
	    wb.Han fHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(fHan, "foo", "1234567");
	    wb.bt_Put(fHan, "foz", "12345678901");
	    wb.bt_Put(fHan, "fonz", "123456789");
	    wb.bt_Put(fHan, "foo", "1234567890");
	    wb.bt_Put(fHan, "food", "1234567890123456");
	    wb.bt_Put(fHan, "test", "123456789012345678901234");
	    wb.bt_Put(fHan, "a", "12345678");
	    scanhan(fHan);
	    wb.dprintf("   TEST 6: split block by deleting the first data element with REM\n");
	    wb.dprintf("   TEST 6: then reentering the first data element with 1 more char\n");
	    wb.bt_Rem(fHan, "a");
	    wb.dprintf("   TEST 6: doing a PUT\n");
	    wb.bt_Put(fHan, "a", "123456789");
	    scanhan(fHan);
	    wb.closeBt(fHan);
	}

	/*  THIS IS TEST #7 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block , then it deletes a middle element. It then */
	/*  tries to make the block split by reentering a middle element with 1 */
	/*  more char than the original */

	public static void test7()
	{
	    wb.Han gHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(gHan, "foo", "1234567");
	    wb.bt_Put(gHan, "foz", "12345678901");
	    wb.bt_Put(gHan, "fonz", "123456789");
	    wb.bt_Put(gHan, "foo", "1234567890");
	    wb.bt_Put(gHan, "food", "1234567890123456");
	    wb.bt_Put(gHan, "test", "123456789012345678901234");
	    wb.bt_Put(gHan, "a", "12345678");
	    scanhan(gHan);
	    wb.dprintf("   TEST 7: split block by deleting a middle data element\n");
	    wb.dprintf("   TEST 7: then reentering a middle data element with 1 more char\n");
	    wb.dprintf("   TEST 7: than the original value.\n");
	    wb.bt_Rem(gHan, "foo");
	    wb.dprintf("   TEST 7: doing a PUT\n");
	    wb.bt_Put(gHan, "foo", "12345678901");
	    scanhan(gHan);
	    wb.closeBt(gHan);
	}

	/*  THIS IS TEST #8 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block , then it deletes the last element. It then */
	/*  tries to make the block split by reentering the last element with 1 */
	/*  more char than the original */

	public static void test8()
	{
	    wb.Han hHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(hHan, "foo", "1234567");
	    wb.bt_Put(hHan, "foz", "12345678901");
	    wb.bt_Put(hHan, "fonz", "123456789");
	    wb.bt_Put(hHan, "foo", "1234567890");
	    wb.bt_Put(hHan, "food", "1234567890123456");
	    wb.bt_Put(hHan, "test", "123456789012345678901234");
	    wb.bt_Put(hHan, "a", "12345678");
	    scanhan(hHan);
	    wb.dprintf("   TEST 8: split block by deleting the last data element\n");
	    wb.dprintf("   TEST 8: then reentering the last data element with 1 more char\n");
	    wb.dprintf("   TEST 8: than the original value.  Block name is 'h'\n");
	    wb.bt_Rem(hHan, "test");
	    wb.dprintf("   TEST 8: doing a PUT\n");
	    wb.bt_Put(hHan, "test", "12345678901234567890123456");
	    scanhan(hHan);
	    wb.closeBt(hHan);
	}

	/*  THIS IS TEST #9 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block completely then adds a new data element and value */
	/*  to the block to make it split */

	public static void test9()
	{
	    wb.Han iHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(iHan, "foz", "12345678901");
	    wb.bt_Put(iHan, "fonz", "123456789");
	    wb.bt_Put(iHan, "foo", "1234567890");
	    wb.bt_Put(iHan, "food", "1234567890123456");
	    wb.bt_Put(iHan, "test", "123456789012345678901234");
	    wb.bt_Put(iHan, "a", "12345678");
	    wb.dprintf("   TEST 9: The block 'i' is full. Now we are adding a new index to the begining\n");
	    wb.dprintf("   TEST 9: of the block with a value that should make the block split\n");
	    wb.bt_Put(iHan, "1", "123456789");
	    scanhan(iHan);
	    wb.closeBt(iHan);
	}

	/*  THIS IS TEST #10 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block completely then adds a new data element and value */
	/*  to the block to make it split */

	public static void test10()
	{
	    wb.Han jHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(jHan, "foz", "12345678901");
	    wb.bt_Put(jHan, "fonz", "123456789");
	    wb.bt_Put(jHan, "foo", "1234567890");
	    wb.bt_Put(jHan, "food", "1234567890123456");
	    wb.bt_Put(jHan, "test", "123456789012345678901234");
	    wb.bt_Put(jHan, "a", "12345678");
	    wb.dprintf("   TEST 10: The block 'j' is full. Now we are adding a new index to the middle\n");
	    wb.dprintf("   TEST 10: of the block with a value that should make the block split\n");
	    wb.bt_Put(jHan, "fooa", "123456789");
	    scanhan(jHan);
	    wb.closeBt(jHan);
	}

	/*  THIS IS TEST #11 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block completely then adds a new data element and value */
	/*  to the block to make it split */

	public static void test11()
	{
	    wb.Han kHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(kHan, "foz", "12345678901");
	    wb.bt_Put(kHan, "fonz", "123456789");
	    wb.bt_Put(kHan, "foo", "1234567890");
	    wb.bt_Put(kHan, "food", "1234567890123456");
	    wb.bt_Put(kHan, "test", "123456789012345678901234");
	    wb.bt_Put(kHan, "a", "12345678");
	    wb.dprintf("   TEST 11: The block 'k' is full. Now we are adding a new index to the end\n");
	    wb.dprintf("   TEST 11: of the block with a value that should make the block split\n");
	    wb.bt_Put(kHan, "zzz", "123456789");
	    scanhan(kHan);
	    wb.closeBt(kHan);
	}

	/*  THIS IS TEST #12 FOR BLOCK SPLITTING STUFF */
	/*  this test fills a block completely then adds a new data element and value */
	/*  to the block to make it split */

	public static void test12()
	{
	    wb.Han kHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(kHan, "132", "12345678901");
	    wb.bt_Put(kHan, "1233", "1234567890");
	    wb.bt_Put(kHan, "26", "1234567890123456");
	    wb.bt_Put(kHan, "275", "123456789012345678901234");
	    wb.bt_Put(kHan, "84", "12345678");
	    wb.dprintf("TEST 12: The block 'k' is full. Now we are \n" +
		       "adding a new index pastp after b-pos\n");
	    wb.dprintf("   TEST 12: of the block with a value that should make the block split\n");
	    wb.bt_Put(kHan, "82", "123456789");
	    scanhan(kHan);
	    wb.closeBt(kHan);
	}


	public static void test13()
	{
	    wb.Han kHan = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.bt_Put(kHan, "0132", "12345678901");
	    wb.bt_Put(kHan, "01233", "1234567890");
	    wb.bt_Put(kHan, "026", "1234567890123456");
	    wb.bt_Put(kHan, "0275", "123456789012345678901234");
	    wb.bt_Put(kHan, "084", "12345678");
	    wb.dprintf("TEST 13: The block 'k' is full. Now we are adding" +
		       " a new index pastp after b-pos\n");
	    wb.dprintf("   TEST 13: of the block with a value that should make the block split\n");
	    wb.bt_Put(kHan, "082", "123456789");
	    scanhan(kHan);
	    wb.closeBt(kHan);
	}



	public static void test128()
	{
	    test1();
	    test2();
	    test3();
	    test4();
	    test5();
	    test6();
	    test7();
	    test8();
	    test9();
	    test10();
	    test11();
	    test12();
	    test13();
	}


	public static void Main(String[] args)
	{
	    wb.initWb(75, 150, 2048);
	    wb.dprintf("make-seg\n");
	    currentSeg = wb.makeSeg("z", 0x80);
	    //wb.dprintf("close-seg\n");
	    //wb.closeSeg(currentSeg, true);
	    //wb.dprintf("open-seg\n");
	    //currentSeg = wb.openSeg("z", true);
	    wb.dprintf("create-bt\n");
	    currentBt = wb.createBt(currentSeg, wb.indTyp, 0);
	    wb.dprintf("test0!\n");
	    test0(currentBt);
	    wb.dprintf("test!\n");
	    test128();
	    wb.dprintf("add! 10\n");
	    add(0xa);
	    wb.closeSeg(currentSeg, false);
	    currentSeg = wb.openSeg("z", true);
	    currentBt = wb.createBt(currentSeg, wb.indTyp, 0);
	    scanhan(currentBt);
	    wb.closeSeg(currentSeg, false);
	}
    }
}
