%define name wb
%define version 2a3
%define release 1

Name:         %{name}
Release:      %{release}
Version:      %{version}
Packager:     Aubrey Jaffer <agj @ alum.mit.edu>

License:      GPL
Vendor:       Aubrey Jaffer <agj @ alum.mit.edu>
Group:        Development/Libraries
Provides:     wb
Requires:     scm >= 5d6

Summary:      The WB B-Tree Database for C and Scheme
Source:       http://groups.csail.mit.edu/mac/ftpdir/scm/wb-%{version}.zip
URL:          http://people.csail.mit.edu/jaffer/WB.html
BuildRoot:    %{_tmppath}/%{name}-%{version}
Prefix:       /usr

%description
WB is a disk based, sorted associative array C library.  WB has an
optional interface to the SCM Scheme implementation which supports
SLIB relational databases.

%define __os_install_post /usr/lib/rpm/brp-compress

%prep
rm -rf /var/tmp/%{name}-%{version}
%setup -n wb -c -T
cd ..
unzip $RPM_SOURCE_DIR/wb-%{version}.zip

%build
make clean
make SCHLEP=./schlep all

%install
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/bin
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/lib/wb
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/share/java
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/include
make prefix=${RPM_BUILD_ROOT}%{prefix}/ all
make prefix=${RPM_BUILD_ROOT}%{prefix}/ install

mkdir -p ${RPM_BUILD_ROOT}%{prefix}/info/
gzip wb.info
cp wb.info.gz ${RPM_BUILD_ROOT}%{prefix}/info/

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info /usr/info/wb.info.gz /usr/info/dir
/usr/bin/scm -c "(require 'new-catalog)"

%files
%defattr(-, root, root)
%{prefix}/bin/wbcheck
%dir %{prefix}/lib/wb
%{prefix}/lib/libwb.a
%{prefix}/lib/wb/libwb.a
%{prefix}/lib/libwb.so
%{prefix}/lib/wb/libwb.so
%{prefix}/lib/wb/wbscm.so
%{prefix}/lib/wb/db.so
%{prefix}/lib/wb/wbtab.scm
%{prefix}/lib/wb/rwb-isam.scm
%{prefix}/lib/Wb.dll
%{prefix}/lib/wb/Wb.dll
%{prefix}/share/java/wb.jar
%{prefix}/include/wb/*.h
%{prefix}/include/wbsys.h
/usr/info/wb.info.gz
%doc ANNOUNCE COPYING README ChangeLog

%changelog
